package naeem;

import hossein.Bridge;
import hossein.LAN;

import java.util.Collection;
import java.util.Iterator;

public class NextBridgeLANs {
	Collection connectedLAN;

	Integer[] connectedLANId;

	Iterator[] connectedLANBridges;

	Bridge[] bridgesToMerge;

	public FoundBridge getMin() {
		int min = -1;
		int imin = -1;

		for (int i = 0; i < bridgesToMerge.length; i++) {
			if (bridgesToMerge[i] != null) {
				min = bridgesToMerge[i].getId();
				imin = i;
				break;
			}
		}

		for (int i = 0; i < bridgesToMerge.length; i++) {
			if (bridgesToMerge[i] != null && bridgesToMerge[i].getId() < min) {
				min = bridgesToMerge[i].getId();
				imin = i;
			}
		}

		Bridge minBridge = null;

		if (imin != -1) {
			minBridge = bridgesToMerge[imin];

			if (connectedLANBridges[imin].hasNext())
				bridgesToMerge[imin] = (Bridge) connectedLANBridges[imin]
						.next();
			else
				bridgesToMerge[imin] = null;
		}

		if (imin == -1)
			return null;

		return new FoundBridge(minBridge, connectedLANId[imin]);
	}

	public NextBridgeLANs(Integer connectorLAN, Bridge bridge) {
		connectedLAN = bridge.getLANs();
		connectedLANId = new Integer[connectedLAN.size()];
		connectedLANBridges = new Iterator[connectedLAN.size()];
		bridgesToMerge = new Bridge[connectedLAN.size()];

		Iterator connectedLANsIt = connectedLAN.iterator();
		int index = 0;

		while (connectedLANsIt.hasNext()) {
			LAN theConnectedLAN = (LAN) connectedLANsIt.next();

			if (!theConnectedLAN.isVisited()) {
				connectedLANBridges[index] = theConnectedLAN.getBridges()
						.iterator();
				connectedLANId[index] = new Integer(theConnectedLAN.getId());
				theConnectedLAN.setVisited();
			} else {
				connectedLANBridges[index] = null;
				connectedLANId[index] = null;

				if (theConnectedLAN.getId() != connectorLAN.intValue()) {
					System.out.println(" The bridge #" + bridge.getId()
							+ " must be cut from LAN #"
							+ theConnectedLAN.getId());
				}
			}

			index++;
		}

		for (int i = 0; i < connectedLAN.size(); i++) {
			if (connectedLANBridges[i] != null
					&& connectedLANBridges[i].hasNext())
				bridgesToMerge[i] = (Bridge) connectedLANBridges[i].next();
			else
				bridgesToMerge[i] = null;
		}
	}
}